#-----------------------------------------------------------------------
# Pacotes.

suppressMessages(library(shiny))
suppressMessages(library(bs4Dash))
suppressMessages(library(shinyWidgets))

# Defina `test_mode = TRUE` para usar um chat lorem ipsum durante do
# desenvolvimento. Defina `test_mode = FALSE` para usar o chat real.
options(test_mode = FALSE)
# options()$test_mode

# ATTENTION: Usar esse código para rodar.
# Rscript -e 'shiny::runApp(port = 3838, launch.browser = function(appUrl) { utils::browseURL(paste0(appUrl, "/?token=teste")) })'

#-----------------------------------------------------------------------
# Enviar com click do botão.

# browseURL("https://stackoverflow.com/questions/32335951/using-enter-key-with-action-button-in-r-shiny")
jscode <- '
$(function() {
  var $els = $("[data-proxy-click]");
  $.each(
    $els,
    function(idx, el) {
      var $el = $(el);
      var $proxy = $("#" + $el.data("proxyClick"));
      $el.keydown(function (e) {
        if (e.keyCode == 13) {
          $proxy.click();
        }
      });
    }
  );
});'

# css <- ''

#-----------------------------------------------------------------------
# Interface do usuário.

ui_auth <-
    tagList(
        # Área pra o chat ----
        fluidRow(
            class = "justify-content-center",
            bs4Dash::userMessages(
                status = "primary",
                id = "MESSAGE_AREA"
            )
        ), # fluidRow()
        fluidRow(
            class = "justify-content-center",
            column(
                id = "COLUMN_INPUT_MESSAGE",
                width = 6,
                # Para indicar carregamento.
                tags$div(id = "loading",
                         style = "display: none;",
                         waiter::spin_three_bounce()),
                tagAppendAttributes(
                    textAreaInput(
                        inputId = "INPUT_MESSAGE",
                        label = "Mensagem",
                        placeholder = "Digite sua mensagem aqui...",
                        height = "150px",
                        width = "100%"
                    ),
                    `data-proxy-click` = "SEND_MESSAGE"
                ),
                actionButton(
                    inputId = "SEND_MESSAGE",
                    label = "Enviar",
                    class = "btn-success float-right",
                    icon = icon("envelope")
                )
            )
        ) # fluidRow()
    ) # tagList()

shinyUI(fluidPage(
    header = list(
        phosphoricons::html_dependency_phosphor()
    ),
    class = "container",
    # verbatimTextOutput("TOKEN"),
    # Para enviar com o Enter ----
    tags$head(tags$script(HTML(jscode))),
    # Definições CSS experimentais ----
    # tags$head(tags$style(HTML(css))),
    # Aponta para CSS que aplica cores da Agrinvest ----
    tags$head(tags$link(
        rel = "stylesheet",
        type = "text/css",
        href = "custom.css")),
    # Habilita o uso do {bs4Dash} no Shiny ----
    # shinyWidgets::useBs4Dash(),
    useBs4Dash(),
    # Habilita o uso do {shinyjs} no Shiny ----
    shinyjs::useShinyjs(),
    # Habilita o uso do {waiter} no Shiny ----
    waiter::use_waiter(),
    # Para usar o {typed.js} no Shiny ----
    tags$head(tags$script(src = "typed.min.js")),
    # Logo da Agrinvest ----
    fluidRow(
        class = "justify-content-center mt-3 mb-3",
        img(width = 200,
            # src = "Agrinvest.jpg",
            src = "grao_guru_logo.svg",
            class = "img-fluid",
            height = "auto")
    ),
    # Conteúdo principal ----
    ui_auth
))
